/// <reference types="dist" />
import { Device } from "./device";
import { GPUBufferStorage, UntypedStorage } from "./storage";
import { Kernel, KernelConfig, KernelSpec } from "./kernel";
import { ATypedArray, Dtype } from "./dtype";
export declare class DeviceWebGPU extends Device {
    private _device;
    get gpuDevice(): GPUDevice;
    constructor(id: string, adapter: GPUAdapter, device: GPUDevice);
    alloc(byteSize: number): GPUBufferStorage;
    createKernel(spec: KernelSpec, config: KernelConfig): Kernel;
    getStorageFromKernel(storage: ATypedArray | GPUBuffer): UntypedStorage;
    getBufferForKernel(storage: UntypedStorage, dtype: Dtype): ATypedArray | GPUBuffer;
}
